import QtQuick
import Qt5Compat.GraphicalEffects

import roulette

Item {
    property int numberOfBets: 0

    id: rouletteTable

    Image {
        source: "qrc:///roulette.png"

        height: parent.height
        width: parent.width

        anchors {
            top: parent.top
            right: parent.right
        }

        StreetBetsView {
        }

        Columns {
        }

        Dozens {
        }

        Singles{
        }
    }

    function destroyOnClose(obj) {
        if (obj.closing != undefined)
            obj.closing.connect(() => obj.destroy(1000));
        else if (obj.aboutToHide != undefined)
            obj.aboutToHide.connect(() => obj.destroy(1000));
    }

    /* Call this function to dynamically create a dialog box */
    function showBetInputDialog(betType, n, squareX, squareY)
    {
        var component = Qt.createComponent("BetInputDialog.qml")
        if (component.status == Component.Ready) {
            var dialog = component.createObject(rouletteTable, {
                "betType": betType,
                "n": n,
                "squareX": squareX,
                "squareY": squareY
            })

            dialog.open()
            destroyOnClose(dialog)
        } else {
            console.error("Something crapped out: " + component.errorString());
        }
    }
}
